#!/usr/bin/env python
# Python script to be run in Moneydance to perform amazing feats of financial scripting.

global moneydance                           # Entry point into the Moneydance API
mdGUI = moneydance.getUI()                  # Entry point into the GUI
book = moneydance.getCurrentAccountBook()   # Entry point into your dataset

import sys, time, platform
from java.lang import System
from com.infinitekind.moneydance.model import AccountUtil, AcctFilter, Account
if moneydance.getBuild() >= 5100: from com.infinitekind.util import AppDebug

print("")
print("Java version:              %s" %(System.getProperty("java.version")))
print("Py(Jy)thon platform:       %s %s %s.%s" %(platform.python_implementation(), platform.system(), sys.version_info.major, sys.version_info.minor))
print("")
print("Moneydance version:        MD%s(%s)" %(moneydance.getVersion(), moneydance.getBuild()))
print("The Moneydance controller: %s >> (the global variable 'moneydance' accesses this key object)" %(moneydance))
print("The UI:                    %s" %(mdGUI))
print("The current data set:      '%s'" %(book))

if book is not None:
    tSet = book.getTransactionSet()
    allAccounts = AccountUtil.allMatchesForSearch(book, AcctFilter.ALL_ACCOUNTS_FILTER)
    print("")
    print("Number of transactions in this dataset: %s" %(tSet.getTransactionCount()))
    print("Number of Accounts:                     %s" %(len([a for a in allAccounts if not a.getAccountType().isCategory() and a.getAccountType() != Account.AccountType.ROOT])))
    print("Number of Categories:                   %s" %(len([a for a in allAccounts if a.getAccountType().isCategory()])))
    print("------")
    msgStr = "Hello world... Printing to Moneydance's console from this python script...."
    if moneydance.getBuild() >= 5100:
        AppDebug.ALL.log(msgStr)        # This is how you write to the Moneydance Console (post MD2024)
    else:
        System.err.println(msgStr)      # This is how you write to the Moneydance Console (pre MD2024)

    mdGUI.showInfoMessage("Welcome to Moneydance scripting!")
# END OF SAMPLE SCRIPT #
